M=0.05;
g=9.81;
L=0.01;
R=1;

x10=2;
x20=0;
x30=sqrt(M*g*x10);


%-------------------------------------------------
% Sintesi in frequeza

F=tf(-2*(g/M/x10)^(1/2), [L*x10 R*x10  -L*g  -R*g])

Kc=-1;
figure(1)
bode(Kc*F)

m=10;tau=15;
R_ant=tf([m/tau 1],[1/tau 1])
hold on
Contr=Kc*R_ant;
bode(Kc*R_ant*F)
hold off

radici=roots(F.den{1})
figure(3)
rlocus(F)

figure(2)
nyquist(F)
hold on
nyquist(Kc*R_ant*F)
hold off
%------------------------------------------------
% Spostamento di un solo autovalore

A=[0 1 0;
   g/x10 0 -2*sqrt(g/M/x10);  
   0 0 -R/L];

B=[0 0 1/L]';

C=[1 0 0];

D=[0];

[V,lambda]=eig(A');
Vs=V';


Ldes=-10;
vi=Vs(2,:);
Ki=(lambda(2,2)-Ldes)/(vi*B);
eig((A-B*Ki*vi))


%------------------------------------------------
% Spostamento di tutti gli autovalori
Ragg=[B A*B A*A*B];
Ragg_1=inv(Ragg);
gamma=Ragg_1(3,:);

P=(A+30*eye(3))^3;
Ka=-gamma*P;

eig(A+B*Ka)


%--------------------------------------------------
% Spostamento di tutti gli autovalori con Osservatore

Ragg=[B A*B A*A*B];
Ragg_1=inv(Ragg);
gamma=Ragg_1(3,:);

P=(A+10*eye(3))^3;
Kx=-gamma*P;

eig(A+B*Kx)


Oss=[C;C*A;C*A*A];
Oss_1=inv(Oss);
gamma2=Oss_1(:,3);
Pe=(A+100*eye(3))^3;  % 2000
Ky=Pe*gamma2;

Aoss=(A-Ky*C);
Boss=[B Ky];
Coss=eye(3);
Doss=zeros(3,2);


%------------------------------
N=[A B; C 0];
N_1=inv(N)


